package edu.uoc.pfc.statusdroid.activity;

import java.util.List;

import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import edu.uoc.pfc.statusdroid.R;
import edu.uoc.pfc.statusdroid.exception.StatusDroidException;
import edu.uoc.pfc.statusdroid.helper.StatusArrayAdapter;

/**
 * Classe que conté la lògica de l'activitat per la pestaña d'informació
 * pública.
 * 
 * @author daniel
 * 
 */
public class HomeStatusActivity extends StatusDroidBaseActivity {

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.messages_list);
	}

	@Override
	public void onResume() {
		super.onResume();
		if (mBound) {
			if (statusNetAPI.getService().isConnected()) {
				new StatusTask().execute(new String[1]);
			}
		}
	}

	@Override
	public void loadServiceAction() {
		if (statusNetAPI.getService().isConnected()) {
			new StatusTask().execute(new String[1]);
		}
	}

	private class StatusTask extends
			AsyncTask<String, Void, List<edu.uoc.pfc.statusdroid.model.Status>> {

		private StatusDroidException exc;

		@Override
		protected void onPostExecute(
				List<edu.uoc.pfc.statusdroid.model.Status> statuses) {
			if (null != exc) {
				showErrorAlert(exc.getMessage());
				return;
			}
			ListView messagesListView = (ListView) findViewById(R.id.message_list_view);
			StatusArrayAdapter<edu.uoc.pfc.statusdroid.model.Status> adapter = new StatusArrayAdapter<edu.uoc.pfc.statusdroid.model.Status>(
					getApplicationContext(), R.layout.status_item, statuses);
			// Menú d'accions
			messagesListView
					.setOnItemClickListener(new AdapterView.OnItemClickListener() {

						public void onItemClick(AdapterView<?> parent,
								View view, int position, long id) {
							showMessageQuickAction(parent, view, position);
						}

					});
			messagesListView.setAdapter(adapter);
			messagesListView.invalidate();
		}

		@Override
		protected List<edu.uoc.pfc.statusdroid.model.Status> doInBackground(
				String... params) {
			List<edu.uoc.pfc.statusdroid.model.Status> statuses;
			try {
				statuses = statusNetAPI.getHomeTimeLine();
			} catch (StatusDroidException e) {
				exc = e;
				return null;
			}
			return statuses;
		}
	}
}
