package edu.uoc.pfc.statusdroid.content;

import android.net.Uri;
import android.provider.BaseColumns;

public final class StatusDroidDB {

	/**
	 * Autoritat per accedir a les dades
	 */
	public static final String AUTHORITY = "edu.uoc.pfc.statusdroid.activity.content.serverconfig";

	// Es un contracte d'ús intern, no permetem que s'instancii
	private StatusDroidDB() {
	}

	public static final class ServerConfig implements BaseColumns {
		/**
		 * Nom de la taula associada a aquest proveidor
		 */
		public static final String TABLE_NAME = "serverConfig";

		/* URIs associades a aquest proveïdor */

		/**
		 * Esquema principal sobre el qual trobarem les dades
		 */
		private static final String SCHEME = "content://";

		/**
		 * Path per a accedir a les dades de configuracio
		 */
		private static final String PATH_SERVER_CONFIG = "/serverConfig";

		/**
		 * Path per accedir a una configuracio pel seu ID
		 */
		private static final String PATH_SERVER_CONFIG_ID = "/serverConfig/";

		/**
		 * Posició relativa on es troba l'id de configuració
		 */
		public static final int SERVERCONFIG_ID_POSITION = 1;

		/**
		 * URI d'accés a la taula
		 */
		public static final Uri CONTENT_URI = Uri.parse(SCHEME + AUTHORITY
				+ PATH_SERVER_CONFIG);

		/**
		 * URI d'accés a una configuració
		 */
		public static final Uri CONTENT_ID_URI = Uri.parse(SCHEME + AUTHORITY
				+ PATH_SERVER_CONFIG_ID);

		/*
		 * Tipus MIME dels continguts
		 */

		/**
		 * Conjunt de configuracions
		 */
		public static final String CONTENT_TYPE = "vnd.android.cursor.dir/vnd.statusdroid.serverconfig";

		/**
		 * Configuració d'un servidor concret
		 */
		public static final String CONTENT_ITEM_TYPE = "vnd.android.cursor.item/vnd.statusdroid.serverconfig";

		/**
		 * Ordenació per defecte de les configuracions
		 */
		public static final String DEFAULT_SORT_ORDER = "_id ASC";

		/*
		 * Columnes de la taula
		 */
		/**
		 * Configuració de la URI del servidor. Tipus de contingut: TEXT.
		 */
		public static final String COLUMN_SERVER_NAME = "serverName";
		public static final String COLUMN_SERVER_NAME_TYPE = "TEXT";

		/**
		 * Configuració de la URI del servidor. Tipus de contingut: TEXT.
		 */
		public static final String COLUMN_SERVER_URI = "serverUri";
		public static final String COLUMN_SERVER_URI_TYPE = "TEXT";

		/**
		 * Configuració de la connexió per defecte. Tipus de contingut: TEXT.
		 */
		public static final String COLUMN_SERVER_AUTOCONN = "autoconn";
		public static final String COLUMN_SERVER_AUTOCONN_TYPE = "TEXT";

		/**
		 * Configuració del nom d'usuari. Tipus de contingut: TEXT.
		 */
		public static final String COLUMN_SERVER_USER = "user";
		public static final String COLUMN_SERVER_USER_TYPE = "TEXT";

		/**
		 * Configuració del password d'usuari. Tipus de contingut: TEXT.
		 */
		public static final String COLUMN_SERVER_PASSWORD = "password";
		public static final String COLUMN_SERVER_PASSWORD_TYPE = "TEXT";
	}
}
