package edu.uoc.pfc.statusdroid.helper;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import edu.uoc.pfc.statusdroid.R;
import edu.uoc.pfc.statusdroid.model.ServerConfigData;

public class ServerConfigArrayAdapter<E> extends ArrayAdapter<E> {

	private ServerConfigData connectedServerConfig;

	public ServerConfigData getConnectedServerConfig() {
		return connectedServerConfig;
	}

	public void setConnectedServerConfig(ServerConfigData connectedServerConfig) {
		this.connectedServerConfig = connectedServerConfig;
	}

	public ServerConfigArrayAdapter(Context context, int textViewResourceId,
			List<E> objects, ServerConfigData connectedServerConfig) {
		super(context, textViewResourceId, objects);
		this.connectedServerConfig = connectedServerConfig;

	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		if (convertView == null) {
			LayoutInflater inflater = (LayoutInflater) getContext()
					.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			convertView = inflater.inflate(R.layout.config_item, null);
		}

		ServerConfigData serverConfig = (ServerConfigData) getItem(position);
		if (convertView != null) {
			// Icona connexió
			if (null != connectedServerConfig
					&& serverConfig.getId() == connectedServerConfig.getId()) {
				ImageView imgView = (ImageView) convertView
						.findViewById(R.id.server_connect);
				imgView.setVisibility(View.VISIBLE);
			}

			// Nom Config
			TextView serverConfigName = (TextView) convertView
					.findViewById(R.id.server_config_name);
			serverConfigName.setText(serverConfig.getName());

			// Server URL
			TextView serverConfigURL = (TextView) convertView
					.findViewById(R.id.server_config_url);
			serverConfigURL.setText(serverConfig.getUrl());

		}
		return convertView;

	}
}