package edu.uoc.pfc.statusdroid.helper;

import java.util.List;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import edu.uoc.pfc.statusdroid.R;
import edu.uoc.pfc.statusdroid.model.Status;
import edu.uoc.pfc.statusdroid.utils.StatusDroidUtils;

public class StatusArrayAdapter<E> extends ArrayAdapter<E> {

	public StatusArrayAdapter(Context context, int textViewResourceId,
			List<E> objects) {
		super(context, textViewResourceId, objects);

	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		if (convertView == null) {
			LayoutInflater inflater = (LayoutInflater) getContext()
					.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			convertView = inflater.inflate(R.layout.status_item, null);
		}

		Status status = (Status) getItem(position);
		if (convertView != null) {
			// Avatar

			ImageView imgView = (ImageView) convertView
					.findViewById(R.id.user_image);
			if (null != status.getUser()
					&& null != status.getUser().getProfile_image_url()) {
				Drawable image = StatusDroidUtils.recoverImage(status.getUser()
						.getProfile_image_url());

				imgView.setImageDrawable(image);
			}
			// Nom Usuari
			TextView userName = (TextView) convertView
					.findViewById(R.id.user_name);
			userName.setText(status.getUser().getName());

			// Text
			TextView messageText = (TextView) convertView
					.findViewById(R.id.message_text);
			messageText.setText(status.getText());

			// Data
			TextView messageDate = (TextView) convertView
					.findViewById(R.id.message_date);
			messageDate.setText(status.getCreated_at());
		}
		return convertView;

	}
}