package edu.uoc.pfc.statusdroid.model;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Classe que guarda les dades de configuració d'un servidor StatusNet
 * 
 * @author daniel
 */
public class ServerConfigData implements Parcelable {
	private int id;
	private String name;
	private String url;
	private boolean autconn;
	private String user;
	private String password;

	public ServerConfigData() {

	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url.trim();
	}

	public boolean isAutconn() {
		return autconn;
	}

	public void setAutconn(boolean autconn) {
		this.autconn = autconn;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user.trim();
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password.trim();
	}

	@Override
	public String toString() {
		return this.name;
	}

	// Implementació mètodes construcció Parcelable
	public int describeContents() {
		return 0;
	}

	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(id);
		dest.writeString(name);
		dest.writeString(url);
		if (autconn) {
			dest.writeString("true");
		} else {
			dest.writeString("false");
		}
		dest.writeString(user);
		dest.writeString(password);
	}

	// Implementació mètodes reconstrucció Parcelable
	public static final Parcelable.Creator<ServerConfigData> CREATOR = new Parcelable.Creator<ServerConfigData>() {
		public ServerConfigData createFromParcel(Parcel in) {
			return new ServerConfigData(in);
		}

		public ServerConfigData[] newArray(int size) {
			return new ServerConfigData[size];
		}
	};

	// Constructor per reconstuir les dades
	private ServerConfigData(Parcel in) {
		id = in.readInt();
		name = in.readString();
		url = in.readString();
		autconn = new Boolean(in.readString());
		user = in.readString();
		password = in.readString();
	}

	@Override
	public boolean equals(Object o) {
		if (!(o instanceof ServerConfigData)) {
			return false;
		}
		return this.id == ((ServerConfigData) o).getId();
	}
}
