package edu.uoc.pfc.statusdroid.service;

import android.app.IntentService;
import android.content.Intent;
import android.os.IBinder;
import edu.uoc.pfc.statusdroid.model.ServerConfigData;
import edu.uoc.pfc.statusdroid.model.User;

public class StatusNetAPIService extends IntentService {

	public static boolean mBound;
	private final IBinder statusNetAPIBinder = new StatusNetAPIBinder(this);
	private ServerConfigData currentServer;
	private User user;
	private boolean connected;

	public boolean isConnected() {
		return connected;
	}

	public void setConnected(boolean connected) {
		this.connected = connected;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public ServerConfigData getCurrentServer() {
		return currentServer;
	}

	public void setCurrentServer(ServerConfigData currentServer) {
		this.currentServer = currentServer;
	}

	public StatusNetAPIService() {
		super("StatusNetAPIService");
	}

	@Override
	public IBinder onBind(Intent arg0) {
		mBound = true;
		return statusNetAPIBinder;
	}

	@Override
	public boolean onUnbind(Intent intent) {
		if (mBound) {
			mBound = false;
		}
		return super.onUnbind(intent);
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		System.out.println("Handle Intent");
	}

}
